#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

typedef long long ll;

const int maxn=5005;
const ll inf=1e18;
int n;
ll a[maxn],b[maxn];
int p[maxn];
ll dp[maxn][maxn];
ll maxprev[maxn];

void read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i]>>b[i];
    }
    for(int i=1;i<=n;i++)
        cin>>p[i];

    ll ans=0;
    dp[1][0]=a[1];
    maxprev[1]=a[1];
    for(int i=2;i<=n;i++)
    {
        //maxprev[i]=-inf;
        for(int t=0;t<i;t++)
        {
            dp[i][t]=maxprev[i-1]+a[i]+b[i]*t;
            ans=max(ans,dp[i][t]);
            maxprev[i]=max(maxprev[i],dp[i][t]);
        }
    }
    cout<<ans<<endl;
}

int main()
{
    speed();
    read();
    return 0;
}
